<?php
/*
2024/5/18
管理者のグループ登録設定画面

*/

require_once '../data/constant.php';

require_once '../data/db_access.php';
require_once '../data/table_access.php';
require_once '../language/ja_utf8/admin.php';

//require_once '../../../config.php';

global $USER;
global $DB;
require_login();
if (!is_siteadmin($USER->id)) {
    header("Content-Type: text/html; charset=UTF-8");
    header(URL_SET);
    exit;
}

$teacher_arr = array();
$member_arr = array();
$student_arr = array();
$edit_group_id_arr = array();
$delete_group_id_arr = array();
$group_id="";
$group_name = "";

if (!isset($_GET['g_id']) || !is_numeric($_GET['g_id'])){
    header("Content-Type: text/html; charset=UTF-8");
    header(URL_SET);
    exit;
}

$group_id = $_GET['g_id'];
$group_name = $_GET['name'];

if (isset($_POST['teacher']) && $_POST['teacher']==1 && isset($_POST['teacher_sel'])) {
	$teacherid = preg_split("/,/", $_POST['teacher_sel']);
    $sql = "DELETE FROM {x_class_teachers26} WHERE groupid=".intval($group_id);
    $res = $DB->execute($sql);
    $sql = "INSERT INTO {x_class_teachers26} (groupid, uid, linkid) ";
    $sql .= "VALUES (".intval($group_id).",".intval($teacherid[0]).",".intval($teacherid[1]).")";
    $res = $DB->execute($sql);
}
if (isset($_POST['add']) && $_POST['add'] == 1 && isset($_POST['reg_student_sel'])) {
	$items = $_POST['reg_student_sel'];
	foreach($items as $item) {
		$student_id = preg_split("/,/", $item);
		$sql = "INSERT INTO {x_class_student_tbl24} ";
		$sql .= " (uid, groupid, linkid, status) VALUES (".intval($student_id[0]).",".intval($group_id);
		$sql .= ",".intval($student_id[1]).", 1)";
		$res = $DB->execute($sql);
	}
}

if (isset($_POST['del']) && $_POST['del'] == 1 && isset($_POST['del_student_sel'])) {
	$items = $_POST['del_student_sel'];
	$where_st = "";
	foreach($items as $item) {
		$student_id = preg_split("/,/", $item);
		
		$where_st .=" uid =".intval($student_id[0])." OR";
	}

	if ($where_st <> "") {
		$where_st = substr($where_st, 0, -3);
		$sql = "DELETE FROM {x_class_student_tbl24}";
		
		$sql .= " WHERE (".$where_st.") AND groupid=".intval($group_id);
		
		$res = $DB->execute($sql);
	}
}
$member_arr = getGroupMember($group_id);


function getSelectTeacher($member_arr, $teacher_arr) {
//入力は、グループIDとクラス担当者
//グループメンバーの検索開始
	$return_select="<SELECT name='teacher_sel'>";

	foreach($member_arr as $member) {
//studentのidが5でそれ以下
//		if ($member['rank'] >= 1) {
/*
		if ($member['rank'] < 5) {
	    	$return_select .="<OPTION value='".$member['uid'].",".$member['linkid']."' ";
	    	if (in_array($member['uid'],$teacher_arr)) $return_select .="SELECTED";
	    	$return_select .= ">".$member['uname'];
	    	$return_select .="</OPTION>";
		}
		*/
		if ($member->rank < 5) {
	    	$return_select .="<OPTION value='".$member->uid.",".$member->linkid."' ";
	    	if (in_array($member->uid,$teacher_arr)) $return_select .="SELECTED";
	    	$return_select .= ">".$member->uname;
	    	$return_select .="</OPTION>";
		}
	}
    $return_select .="</SELECT>";
    return $return_select;
}

function getSelectStudent($member_arr, $student_arr, $teacher_arr) {
	//入力は、グループ全員と登録受講者と登録教員（教員を外さない場合は、３番目の引数は未使用）
	$return_select = array(2);
	//追加するメンバーのセレクト
	$return_select[0] = "<SELECT name='reg_student_sel[]'multiple='multiple' size=8>";
	//削除するメンバーのセレクト
	$return_select[1] = "<SELECT name='del_student_sel[]'multiple='multiple' size=8>";
	foreach($member_arr as $member) {
		//上のコメントアウトを外すと、
		//教員として設定されているものは受講者にはなれない
		/*
	    if (in_array($member['uid'],$student_arr)) {
	    	$tmp_num =1;
	    } else {
	    	$tmp_num =0;
	    }

	   	$return_select[$tmp_num] .="<OPTION value='".$member['uid'].",".$member['linkid']."' ";
	    $return_select[$tmp_num] .= ">".$member['uname'];
	    $return_select[$tmp_num] .="</OPTION>";
	    */
	    if (in_array($member->uid,$student_arr)) {
	    	$tmp_num =1;
	    } else {
	    	$tmp_num =0;
	    }

	   	$return_select[$tmp_num] .="<OPTION value='".$member->uid.",".$member->linkid."' ";
	    $return_select[$tmp_num] .= ">".$member->uname;
	    $return_select[$tmp_num] .="</OPTION>";
	}
    $return_select[0] .="</SELECT>";
    $return_select[1] .="</SELECT>";
    return $return_select;
}

function getGroupMember ($groupid) {
//グループIDが入力
	global $DB;
	$return_arr = array();
    $sql = "SELECT u.username AS uname, u.id AS uid, l.id AS linkid, MIN(r.id) AS rank ";
    $sql .= "FROM {course} AS g, {user} AS u, {role_assignments} AS l, ";
    $sql .= "{role} AS r, {context} AS c ";
    
    $sql .= "WHERE l.userid=u.id AND l.contextid= c.id AND g.id=c.instanceid AND r.id=l.roleid AND g.id = '".$groupid."'";
    $sql .= " GROUP BY u.username, u.id";
    
    $res = $DB->get_recordset_sql($sql);
    foreach ($res as $item){
		$return_arr[$item->uid] = $item;
    }
	return $return_arr;
}

function getTeacher($groupid) {
	global $DB;
	$return_arr = array();
    $sql = "SELECT u.id AS uid FROM {course} AS g, {user} AS u, {x_class_teachers26} AS l WHERE g.id=l.groupid AND l.uid=u.id AND g.id = '".$groupid."'";
    /*
    $res = $xoopsDB->query($sql);
    while($row = $xoopsDB->fetchArray($res)){
    	array_push($return_arr, $row['uid']);
    }
	return $return_arr;
	*/
	
	$res = $DB->get_recordset_sql($sql);
	foreach ($res as $item) {
		array_push($return_arr, $item->uid);
	}
	
	return $return_arr;
}

function getStudents($groupid) {
	global $DB;
	$return_arr = array();
    $sql = "SELECT u.id AS uid FROM {course} AS g, {user} AS u, {x_class_student_tbl24} AS l WHERE g.id=l.groupid AND l.uid=u.id AND g.id = '".$groupid."'";
    
    /*
    $res = $xoopsDB->query($sql);
    while($row = $xoopsDB->fetchArray($res)){
    	array_push($return_arr, $row['uid']);
    }
    */
    $res = $DB->get_recordset_sql($sql);
	foreach ($res as $item) {
		array_push($return_arr, $item->uid);
	}
	
	return $return_arr;
}

$member_arr = getGroupMember($group_id);
$teacher_arr = getTeacher($group_id);
$student_arr = getStudents($group_id);
$student_sel_arr = array(2);


$show_data = file_get_contents(TEMPLATE_DIR.'admin_moodle/admin_group_edit.tpl');

$show_data = str_replace(':GROUPID_REP:', $group_id, $show_data);
$show_data = str_replace(':GROUP_NAME_REP:', $group_name, $show_data);
$show_data = str_replace(':URLGROUPNAME_REP:', urlencode($group_name), $show_data);
$show_data = str_replace(':TEACHER_SER_REP:', getSelectTeacher($member_arr,$teacher_arr), $show_data);

$student_sel_arr = getSelectStudent($member_arr, $student_arr, $teacher_arr);

$show_data = str_replace(':STU_SEL_ARR0_REP:', $student_sel_arr[0], $show_data);
$show_data = str_replace(':STU_SEL_ARR1_REP:', $student_sel_arr[1], $show_data);



echo $show_data;
?>