<?php
/*
2024/5/15
管理者のトップページ
コースの一覧表示

*/

require_once '../data/constant.php';

require_once '../data/db_access.php';
require_once '../data/table_access.php';
require_once '../language/ja_utf8/admin.php';

//require_once '../../../config.php';

global $USER;
require_login();
if (!is_siteadmin($USER->id)) {
    header("Content-Type: text/html; charset=UTF-8");
    header(URL_SET);
    exit;
}

$desp_table_notregisted = "<tr><td>"._MI_A_IFRIT_CLASS_NAME."</td></tr>";
$desp_table_testable = "<tr><td>"._MI_A_IFRIT_CLASS_NAME."</td><td>"._MI_A_IFRIT_TEACHER_NAME."</td><td>"._MI_A_IFRIT_PARTICI."</td></tr>";
$desp_table_notenough = "<tr><td>"._MI_A_IFRIT_CLASS_NAME."</td></tr>";

$tmp_group_id_arr = array();

global $DB;

//担当教員
$sql1="SELECT ut.lastname, ut.firstname, ct.groupid FROM {user} AS ut, {x_class_teachers26} AS ct";
$sql1 .= " WHERE ut.id = ct.uid";


$tea_data = $DB->get_recordset_sql($sql1);

$tmp_group_id_arr=array();
foreach ($tea_data as $item) {
	$tmp_group_id_arr[$item->groupid]["tea_nam"] = htmlspecialchars($item->lastname,3)." ".htmlspecialchars($item->firstname,3);
}


$sql2 = "SELECT s.groupid, COUNT(ut.id) AS st_num FROM {user} AS ut, {x_class_student_tbl24} AS s ";
$sql2 .= "WHERE ut.id = s.uid GROUP BY groupid";

$st_num_data = $DB->get_recordset_sql($sql2);
foreach ($st_num_data as $item) {
	$tmp_group_id_arr[$item->groupid]["st_num"] = $item->st_num;
}



$sql3 = "SELECT * FROM {course}";
$co_data = $DB->get_recordset_sql($sql3);

$reg_cnt = 0;
$noreg_cnt = 0;
$notenough_cnt=0;

$desp_table_testable = "";
$desp_table_notenough = "";
$desp_table_notregisted = "";


foreach ($co_data as $item) {
	if (isset($tmp_group_id_arr[$item->id])) {
		if (isset($tmp_group_id_arr[$item->id]['tea_nam']) &&
			isset($tmp_group_id_arr[$item->id]['st_num'])) {
			//テストが可能なクラス
			$desp_table_testable .="<tr><td><a href='group_edit.php?g_id=".$item->id;
			$desp_table_testable .="&name=".urlencode($item->shortname)."'>".htmlspecialchars($item->shortname,3);
			$desp_table_testable .="</a></td><td>".$tmp_group_id_arr[$item->id]['tea_nam'];
			$desp_table_testable .="</td><td>".$tmp_group_id_arr[$item->id]['st_num'];
			$desp_table_testable .="</td></tr>\n";
			$reg_cnt++;
			
		} else {
//設定が不十分なクラス
			$desp_table_notenough .="<tr><td><a href='group_edit.php?g_id=".$item->id;
			$desp_table_notenough .="&name=".urlencode($item->shortname)."'>".htmlspecialchars($item->shortname,3);
			$desp_table_notenough .="</a></td></tr>\n";
			$notenough_cnt++;
		}
	} else {
//完全未設定のクラス
		$desp_table_notregisted .="<tr><td><a href='group_edit.php?g_id=".$item->id;
		$desp_table_notregisted .="&name=".urlencode($item->shortname)."'>".htmlspecialchars($item->shortname,3);
		$desp_table_notregisted .="</a></td></tr>\n";
		$noreg_cnt++;
	}
}
if ($reg_cnt == 0) {
   $desp_table_testable = "<tr><td>"._MI_A_IFRIT_REG_NOTFOUND."</td></tr>";
}
if ($noreg_cnt == 0) {
   $desp_table_notregisted = "<tr><td>"._MI_A_IFRIT_NOTREG_NOTFOUND."</td></tr>";
}
if ($notenough_cnt == 0) {
   $desp_table_notenough = "<tr><td>"._MI_A_IFRIT_NOTREG_NOTFOUND."</td></tr>";
}

$show_data = file_get_contents(TEMPLATE_DIR.'admin_moodle/admin_index.tpl');

$show_data = str_replace(':VALID_DATA_TBL_REP:', $desp_table_testable, $show_data);
$show_data = str_replace(':NOT_REGIST_DATA_TBL_REP:', $desp_table_notregisted, $show_data);

$show_data = str_replace(':NOT_ENOUGH_DATA_TBL_REP:', $desp_table_notenough, $show_data);

echo $show_data;

?>